<!--
  @description: 报表统计-采购单位统计-不同采购方式发布的项目数量及完成情况详情
  @Modifier: 郝定康
  @routerPath:
  @date: 2021-01-30
-->
<template>
  <el-dialog
    v-dialogDrag
    :modal="false"
    :visible.sync="dialog"
    :close-on-click-modal="false"
    title="详情"
    width="840px"
  >
    <section class="clearfix">
      <el-form ref="searchForm" :model="searchForm" inline>
        <el-form-item prop="tenderNo" label="工业区">
          <el-input v-model="searchForm.buyersName" />
        </el-form-item>
        <el-form-item class="fr">
          <el-button type="primary" round @click="search">
            查询
          </el-button>
          <el-button type="primary" round @click="resetForm('searchForm')">
            重置
          </el-button>
          <el-button type="primary" style="margin-top:10px;" round @click="exportChange">
            导 出
          </el-button>
          <el-button type="primary" style="margin-top:10px;" round @click="exportAllChange">
            所有采购方式导出
          </el-button>
        </el-form-item>
      </el-form>
    </section>
    <tableChart
      :height="height"
      class="echart-dom"
      :option="option"
    />
    <pagination :pagination-data="paginationData" @change="loadData" />
  </el-dialog>
</template>

<script>
/* api */
import { listProjectCompleteByTenderMethodInfo, exportProjectCompleteByTenderMethodInfo, exportProjectCompleteAllTenderMethod } from '@api/statisticalAnalysis/reportChart.js'
/* 公用方法*/
import { download, filterObj, restoreInitialValue } from '@/assets/js/utils'// 过滤空的key
/* 混合开发方法-参数字段*/
import { ListMixin } from '@/mixins/ListMixin'// 分页
/* 組件 */
import tableChart from './../../components/tableChart'// table列表渲染组件
import pagination from '@comp/common/pagination/pagination'// 分页

export default {
  name: 'BidProjectCompletionRateDetailDialog',
  components: {
    tableChart, // table列表渲染组件
    pagination // 分页
  },
  mixins: [ListMixin],
  data() {
    return {
      height: '450px', // 高度
      dialog: false, // 弹窗状态
      // 查询条件
      searchForm: {
        tenderNo: '' // 工业区
      },
      tenderMethodName: '', // 标题
      // 全局的查询条件
      searchChartData: {
        buyersName: ''
      },
      option: {
        // 非TOP排序
        showIndexTOP: false,
        // 标题
        thead: [
          { lable: '工业区名称', prop: 'buyersName', align: 'left' },
          { lable: '项目（个）', prop: 'projectNumbers', align: 'center' },
          { lable: '项目金额（万元）', prop: 'projectMoney', align: 'center' },
          { lable: '完成项目（个）', prop: 'completeProjectNumbers', align: 'center' },
          { lable: '完成项目金额（万元）', prop: 'completeProjectMoney', align: 'center' }
        ],
        // 渲染数据
        data: []
      }
    }
  },
  methods: {
    /**
     * 打开弹窗
     *  @param {row} Object 供应商信息
     *  @param {searchChartData} Object 全局的查询条件
    */
    open(row, searchChartData) {
      this.tenderMethodName = row.tenderMethodName // 标题
      this.paginationData.pageNo = 1
      this.dialog = true
      this.searchForm = {
        tenderMethod: row.tenderMethod,
        ...searchChartData
      }
      this.loadData()
    },
    // 获取数据
    loadData() {
      this.option.data = []
      const data = this.getParams()
      listProjectCompleteByTenderMethodInfo(data).then(res => {
        this.paginationData.total = res.data.total
        this.option.data.push(...res.data.records)
      })
    },
    // 查询条件
    getParams() {
      const param = {
        ...this.searchChartData,
        ...this.searchForm
      }
      param.pageNo = this.paginationData.pageNo
      param.pageSize = this.paginationData.pageSize
      return filterObj(param)// 过滤空的key
    },
    // 搜索
    search() {
      this.paginationData.pageNo = 1
      this.paginationData.pageSize = 10
      this.loadData()
    },
    // 重置
    resetForm(formName) {
      restoreInitialValue(this.searchForm)
      this.search()
    },
    // 导出
    exportChange() {
      const data = this.getParams()
      exportProjectCompleteByTenderMethodInfo(data).then(res => {
        download(res, '不同采购方式【' + this.tenderMethodName + '】发布的项目数量及完成情况详情表.xls')
      })
    },
    // 所有采购方式导出
    exportAllChange() {
      const data = this.getParams()
      exportProjectCompleteAllTenderMethod(data).then(res => {
        download(res, '所有采购方式发布的项目数量及完成情况详情表.xls')
      })
    }
  }
}
</script>

<style scoped lang="less">
</style>
